// nastavení debugovacího prostředí (výpisy do konzole jsou velmi podrobné)
process.env['DEBUG']='*';

// knihovna pro cteni souboroveho systemu
var fs = require('fs');

// handler pro https requesty
var request_handler = function (req, res) {
}

// konfigurace https
var options = {
    key: fs.readFileSync('/etc/httpd/conf.d/cert/tex.key'),
    cert: fs.readFileSync('/etc/httpd/conf.d/cert/tex.pem')
};

// vytvoření websocketového serveru, který je možný dotazovat přes https
var server = require('https').createServer(options, request_handler);
var io = require('./../libs/node_modules/socket.io')(server);

// inicializace událostí socketu
io.on('connection', function (socket) {
  	//událost, která se volá v případě, že se uživatel připojí do místnosti
	socket.on('join room', function (data) {
 		socket.join(data.sharingConfig.idRoom);
		socket.broadcast.to(data.sharingConfig.idRoom).emit('init sharing', data);
	});

	//změna v dokumentu a následná distribuce spolupracovníkům
	socket.on('document changes', function (data) {
		socket.broadcast.to(data.sharingConfig.idRoom).emit('document changes', data);
        });

	// zjisteni kdo vsechno spolupracuje na otevrenem dokumentu a sdeleni vlastniho loginu
	socket.on('who collaborate', function (data) {	
		socket.broadcast.to(data.sharingConfig.idRoom).emit('check collaborators', data);
	});

	// zaslani pozice kurzoru uzivatele ostatnim
	socket.on('show my position', function (data) {
		socket.broadcast.to(data.sharingConfig.idRoom).emit('show my position', data);
	});

	// zasilani zmeny pozice kurzoru
	socket.on('cursor changes', function (data){
		socket.broadcast.to(data.sharingConfig.idRoom).emit('cursor changes', data);
	});

	socket.on('range changes', function (data){
		socket.broadcast.to(data.sharingConfig.idRoom).emit('range changes', data);
	});

	// sdeleni uzivatelova loginu vsem ostatnim spolupracovnikum
	socket.on('tell login', function (data){
		socket.broadcast.to(data.sharingConfig.idRoom).emit('tell login', {login : data.sharingConfig.user});
	})

  	socket.on('user disconnected', function (data){
		socket.broadcast.to(data.sharingConfig.idRoom).emit('user disconnected', {login : data.sharingConfig.user});
	});
});

// server naslouchá na portu 3000
server.listen(3000);
