$(document).ready(function () {

	// Pocatecni vyska stranky
	var height = 0;

	$('textarea').on('focus', function () {
		// Zachyceni puvodni velikosti stranky
		if (height == 0)
			height = $('body').css('height');
		// Zmenseni stranky na 67% pro portrait orientaci, na 41% pro landscape
		// Nevim, jak zjistit presnou velikost software klavesnice na iOS
		if (Math.abs(window.orientation) === 90) {
        		// Landscape
			$('body').css('height', (window.innerHeight * 0.41) + 'px');
    		} else {
    			// Portrait
			$('body').css('height', (window.innerHeight * 0.67) + 'px');
    		}
		resetEditor();
		// Znemozneni scrollovani celé stránky
		$(window).bind('touchmove', function(e) {	
			if (e.target.className.indexOf('ace_scrollbar') == -1) {		
				e.preventDefault();
			}
			window.scrollTo(0,0);
		});
	});

	$('textarea').on('blur', function () {
		$('body').css('height', height);
        	resetEditor();
        	// Umozneni scrollovani celé stránky
        	$(window).unbind('touchmove');
	});
	
	// Zabraneni centrovani stranky po přechodu na jiný řádek editoru 
	$('textarea').on('select', function () {
		setTimeout(function(){window.scrollTo(0,0);}, 10);
	});

	// Odstraneni focusu u editoru, pokud doslo k zmene orientace
	$(window).on('orientationchange', function () {
		if($('textarea').is(':focus')) {
			$('textarea').blur();
			window.scrollTo(0,0);				 		
		}
	});
	
});

//TODO: Analyzovat funkci, ktera resetuje nastaveni editoru po zmenseni
function resetEditor() {
	    ace.require("ace/ext/language_tools");
            var editor = ace.edit("codeEdit");
            editor.setTheme("ace/theme/texonweb");
            editor.getSession().setMode("ace/mode/texonweb");
            editor.getSession().setUseWrapMode(true);
            editor.setOptions({
               enableBasicAutocompletion: true
            });
            editor.setShowPrintMargin(false);
}
