TOW.AsideLeft = {

	$el: $('aside.left'),

	init: function() {
		this.initElements();
		this.bindEvents();
	},

	initElements: function() {
		this.$btnBackslash = $('#btn-backslash');
		this.$btnBracketLeft = $('#btn-bracket-left');
		this.$btnBracketRight = $('#btn-bracket-right');
		this.$btnPercent = $('#btn-percent');
		this.$btnCaret = $('#btn-caret');
		this.$btnSharp = $('#btn-sharp');
		this.$btnDollar = $('#btn-dollar');
		this.$btnAnd = $('#btn-and');
		this.$btnTilde = $('#btn-tilde');
		this.$btnUnderscore = $('#btn-underscore');
	},

	bindEvents: function() {
		this.$btnBackslash.click(this.events.onBackslashClick);
		this.$btnBracketLeft.click(this.events.onBracketLeftClick);
		this.$btnBracketRight.click(this.events.onBracketRightClick);
		this.$btnPercent.click(this.events.onPercentClick);
		this.$btnCaret.click(this.events.onCaretClick);
		this.$btnSharp.click(this.events.onSharpClick);
		this.$btnDollar.click(this.events.onDollarClick);
		this.$btnAnd.click(this.events.onAndClick);
		this.$btnTilde.click(this.events.onTildeClick);
		this.$btnUnderscore.click(this.events.onUnderscoreClick);
	},

	events: {
		onBackslashClick: function() {
			editor.insert('\\');
			editor.focus();
		},

		onBracketLeftClick: function() {
			editor.insert('{');
			editor.focus();
		},

		onBracketRightClick: function() {
			editor.insert('}');
			editor.focus();
		},

		onPercentClick: function() {
			editor.insert('%');
			editor.focus();
		},

		onCaretClick: function() {
			editor.insert('^');
			editor.focus();
		},

		onSharpClick: function() {
			editor.insert('#');
			editor.focus();
		},

		onDollarClick: function() {
			editor.insert('$');
			editor.focus();
		},

		onAndClick: function() {
			editor.insert('&');
			editor.focus();
		},

		onTildeClick: function() {
			editor.insert('~');
			editor.focus();
		},

		onUnderscoreClick: function() {
			editor.insert('_');
			editor.focus();
		},
	}

};

$(function() {
	TOW.AsideLeft.init();
});