TOW.AsideRight = {

	$el: $('aside.right'),

	init: function() {
		this.initElements();
		this.bindEvents();
	},

	initElements: function() {
		this.$btnArrowLeft = $('#btn-arrow-left');
		this.$btnArrowRight = $('#btn-arrow-right');
		this.$btnArrowUp = $('#btn-arrow-up');
		this.$btnArrowDown = $('#btn-arrow-down');
		this.$btnPageUp = $('#btn-page-up');
		this.$btnPageDown = $('#btn-page-down');
	},

	bindEvents: function() {
		this.$btnArrowLeft.click(this.events.onArrowLeftClick);
		this.$btnArrowRight.click(this.events.onArrowRightClick);
		this.$btnArrowUp.click(this.events.onArrowUpClick);
		this.$btnArrowDown.click(this.events.onArrowDownClick);
		this.$btnPageUp.click(this.events.onPageUpClick);
		this.$btnPageDown.click(this.events.onPageDownClick);
	},

	events: {
		onArrowLeftClick: function() {
			editor.navigateLeft();
			editor.focus();
		},

		onArrowRightClick: function() {
			editor.navigateRight();
			editor.focus();
		},

		onArrowUpClick: function() {
			editor.navigateUp();
			editor.focus();
		},

		onArrowDownClick: function() {
			editor.navigateDown();
			editor.focus();
		},

		onPageUpClick: function() {
			editor.gotoPageUp();
			editor.focus();
		},

		onPageDownClick: function() {
			editor.gotoPageDown();
			editor.focus();
		},
	}

};

$(function() {
	TOW.AsideRight.init();
});