// Globalni objekt TeXonWeb
var TOW = {};

var ESC_KEY = 27;


$(window).on('beforeunload', function() {
	return TranslVar[471];
});


$(function() {

	$pole = $('#pole');
	$pole.hide();


	// Ziskani PDFka s dokumentem
	$('#PDFta').click(function() {
		var obsah = editor.getValue();
		$pole.val(obsah);
		$('#btnPDF').trigger("click");

		//console.log(obsah);
		//$.post( "/~xvybihal/upgrade/", function( data ) {
		//	$( "#nactiPreklad" ).html( data );
		//});
	});


	// Ziskani PDFka s dokumentem
	$('#PDF').click(function() {
		var obsah = editor.getValue();
		$pole.val(obsah);
		$('#btnPDF').click();
	});


	// Zobrazeni logoveho souboru
	$('#log').click(function() {
		// ziskame uzivatelske jmeno
		var user = $('#user').val();
		window.open('/tmp/' + user + '.log');
	});


	// Zobrazeni logoveho souboru
	$('#log2').click(function() {
		// ziskame uzivatelske jmeno
		var user = $('#user').val();
		window.open('/tmp/' + user + '.log');
	});


	$('#PDFpost').click(function() {
		//$.post( "/~xvybihal/upgrade/", $("#pole").serialize(), function( data ) {
		//	console.log(data);
		//});

		var obsah = editor.getValue();

		$.post(this.url, {
				pole: obsah,
				pdf: "PDF",
				preklad: "xetex",
				pruchod: parseInt($('#compilationsCount').val()),
				komprim: 0
			},
			function(data) {
				//$("body").append("<iframe src="+ data.url +" style=display: none; ></iframe>");
				//$("#nactiPreklad").attr("src",data);
				console.log(data);
				//console.log(data.url);
			}
		);
	});


	//Reakce na stisknuti urcite klavesy
	$(document).keyup(function(event) {
		if (event.which === ESC_KEY) {
			// Skryti spravce souboru, pokud byl spusten
			if ($("#fileManager").is(":visible")) {
				event.preventDefault();
				$("#fileManager").toggle("slide", "left", "fast");
				$("body").css("overflow", "");
			}

			// Skryti kontextove nabidky spravce souboru
			if ($("#sideMenuFiles").is(":visible")) {
				event.preventDefault();
				$("#sideMenuFiles").toggle("slide", "left", "fast");
			}

			// Skryti vypisu sablon, pokud jsou zobrazeny
			if ($("#templatesList").is(":visible")) {
				event.preventDefault();
				changeTemplateIconText();
				$("#templatesList").toggle("slide", "left", "fast");
			}
		}
	});


	// Side navigation button panel
	$('.button-panel').resizable({
		minWidth: 70,
		minHeight: 50
	}).draggable();


	$("#menu-button-holder").click(function() {
		//$( "#sideMenuMain" ).slideToggle( "fast" );
		$("#sideMenuMain").toggle("slide", "left", "fast");

		// Skryti spravce souboru, pokud byl spusten
		if ($("#fileManager").is(":visible")) {
			$("#fileManager").toggle("slide", "left", "fast");
			$("body").css("overflow", "");
		}


		// Skryti kontextove nabidky spravce souboru
		if ($("#sideMenuFiles").is(":visible"))
			$("#sideMenuFiles").toggle("slide", "left", "fast");

		// Skryti vypisu sablon, pokud jsou zobrazeny
		if ($("#templatesList").is(":visible")) {
			changeTemplateIconText();
			$("#templatesList").toggle("slide", "left", "fast");
		}
	});


	$("#new_document").click(function() {
		window.location.href = ".";
	});


	$("#open_empty_list").click(function() {
		window.open(".", "_blank");
	});


	// Uzavirani bocni nabidky a nastaveni
	$("textarea").focus(function() {
		if ($("#sideMenuMain").is(":visible"))
			$("#sideMenuMain").toggle("slide", "left", "fast");

		if ($('#sideMenuSettings').is(':visible'))
			$('#sideMenuSettings').toggle('slide', {
				direction: 'right'
			}, 'fast');
	});


	// Zmena sirky pri otoceni mobilniho zarizeni
	$(window).on("orientationchange", function() {
		if ($(".sideContent").is(":visible")) {
			setWidthSideContent();
		}
	});


	// zobrazi uzivatelske menu po kliknuti na jmeno prihlaseneho uzivatele
	$('#logged-user').click(function() {
		$('#userMenu').toggle();
	});


	// po kliknuti odhlasi uzivatele a presmeruje na neprihlasenou stranku
	$('#logout').click(function() {
		var currentUrl = window.location;
		var finalUrl = currentUrl.toString()
			.replace(/auth[\/]/i, "")
			.replace(/[\?].*/, "")
			.replace(/\#$/, "");
		logoutUser(finalUrl);
	});


	// set default options for all future tooltip instances
	$.fn.tooltipster('setDefaults', {
		theme: 'tooltipster-shadow'
	});

});


/*****************************************************************
 * GLOBAL FUNCTIONS
 *****************************************************************/

var sideContentWidthLandscape = "76.2%";
var sideContentWidthPortrait = "74.8%";

// Promenna urcijici zda je uzivatel autentizovan
var isAuth = true;
// Verzovani souboru vypnuto
var isVersion = false;
// Promenna urcijici zda skript frameworku Socket.io byl nacten do HTML
var isSocketIOloaded = false;


// Funkce pro nastaveni sirky obsahu vyjizdeci nabidky pro spravce souboru
function setWidthSideContent() {
	// spousti se jen na mobilnich zarizenich
	if (!isDesktop()) {
		if (Math.abs(window.orientation) === 90) {
			// Landscape
			$('.sideContent').css('width', sideContentWidthLandscape);
		} else {
			// Portrait
			$('.sideContent').css('width', sideContentWidthPortrait);
		}
	}
}


// Funkce pro rozpoznani desktopu a mobilniho zarizeni
function isDesktop() {
	if (window.orientation === undefined) {
		return true;
	} else {
		return false;
	}
}


// Funkce vracejici, zda je uzivatel autentizovan
function isUserAutheticated() {
	var user = $('#user').val();
	if (user == "default") {
		return false;
	} else {
		return true;
	}
}


// Funkce pro vraceni jmena uzivatele
function getUserName() {
	return $('#user').val();
}


// Obali vybrany text retezcem
function obal(pred, za, e) {
	var range = e.getSelectionRange();
	var ret = e.session.getTextRange(e.getSelectionRange());
	e.insert(pred + ret + za);
}


// Vlozeni TEX makra
function insertMacro(name) {
	obal("\\" + name + "{", "}", editor);
	editor.navigateLeft();
	editor.focus();
}


// Odhlaseni uzivatele
function logoutUser(final_url) {
	//pokazde nahodne username a heslo, aby se zamezilo tomu, ze si je nekdo zaregistruje
	var randUser = getRandomInt(1024, 65565),
		randPassword = getRandomInt(1024, 65565),
		out = window.location.href.replace(/:\/\//, '://' + randUser + ':' + randPassword + '@');

	//console.log(randUser + ":" + randPassword + ">>>" + out);

	jQuery.get(out).error(function() {
		window.location = final_url;
	});
}


function getRandomInt(min, max) {
	return Math.floor(Math.random() * (max - min + 1)) + min;
}
