$(function (){
	if (isUserAutheticated()) {
	// Socket.io, tento kod se spousti pouze v pripade, ze bezi WebSocket server ulozeny v ./WebSocketServer/server.js		
	if (isSocketIOloaded) {
			// Instance Socket.io frameworku
			var socket = io.connect('tex.mendelu.cz:3000');
			// Objekt obsahujici ID mistnosti a login uzivatele
			var sharingConfig = null;
		
			// Pripojeni do mistnosti v pripade otevreneho souboru
			socket.on('connect', function (msg){
				if (isFileOpen()) {
					var pomURL = window.location.toString();
                			// ziskani cesty pro vypocitani hashe
                			var pozice = pomURL.indexOf("=") + 1;
                			var path = pomURL.substr(pozice);
					if (path.indexOf('#') != -1) {
						path = path.substr(0, path.indexOf('#'));
					}
					pozice = path.lastIndexOf("/");
                			var dir_nm = path.substring(0,pozice+1);
					var file_nm = path.substr(pozice+1);

					// Ziskani hashe souboru, ktery predstavuje id mistnosti, ve ktere probiha vymena zmen pres WebSocket
					$.post("sprava_souboru.pl", {hash: "hash", path: dir_nm, filename: file_nm}, function(data){
						data = data.trim();
						sharingConfig = {user : getUserName(), idRoom : data};
						socket.emit('join room', {sharingConfig : sharingConfig, cursorPosition : editor.selection.getCursor()});
						// zeptame se kdo vsechno spolupracuje na dokumentu
					});	
				}	
  			});

			socket.on('document changes', function (msg){
				var editorChanges = msg.editorChanges.data;
				
				if (editorChanges.action == "insertText") {
					if (editorChanges.text != "\n") {
						var lineOnInsrtCord = editor.session.getLine(editorChanges.range.start.row);
						var charactersOnInsertCord = lineOnInsrtCord.substr(editorChanges.range.start.column, editorChanges.text.length);
						if (charactersOnInsertCord != editorChanges.text) {
							editor.session.getDocument().applyDeltas([msg.editorChanges.data]);
						}
					} else {
						var clientCursor = editor.selection.getCursor();
						if (editorChanges.range.end.row != clientCursor.row || editorChanges.range.end.column != clientCursor.column) {
							editor.session.getDocument().applyDeltas([msg.editorChanges.data]);
						} 
					}
				} else if (editorChanges.action == "insertLines"){
					var lines = editorChanges.lines;
					var isExist = false;
					var startLine = editorChanges.range.start.row + 1;
					var strLn = startLine;
					var lineOnInsrtCord = "";
	
					for (var i = 0; i < lines.length; i++) {
						lineOnInsrtCord = editor.session.getLine(startLine);
						if (lineOnInsrtCord == lines[i]) {
							isExist = true;
						}
						startLine++;					
					}
					
					if (!isExist) {
						editor.session.getDocument().applyDeltas([msg.editorChanges.data]);
					}
				} else {
					editor.session.getDocument().applyDeltas([msg.editorChanges.data]);
				}
  			});

			socket.on('cursor changes', function (msg){
				removeUserCursorFromEditor(msg.sharingConfig.user);
				// vytvoreni noveho kursoru
				var Range = ace.require('ace/range').Range;
				var rangeSent = msg.cursor;
				// Urceni pozice kursoru spolupracovnika
				var rng = new Range(rangeSent.row, rangeSent.column, rangeSent.row, rangeSent.column + 1);
				editor.session.addMarker(rng, msg.sharingConfig.user, true);
			});

			socket.on('range changes', function (msg){
				if (msg.range.start.row != msg.range.end.row || msg.range.start.column != msg.range.end.column) {
					var Range = ace.require('ace/range').Range;
					var rng = new Range(msg.range.start.row, msg.range.start.column, msg.range.end.row, msg.range.end.column);
					editor.selection.addRange(rng, false);
				} 
			});
		
			// spolupracovnik se pripojil k dokumentu
			socket.on('init sharing', function (msg){
				// pokusime se odstranit jeho stary kurzor					
				removeUserCursorFromEditor(msg.sharingConfig.user);
				// vygenerujeme mu novou barvu
				generateCursorStyle(msg.sharingConfig.user);
				var Range = ace.require('ace/range').Range;
				var rng = new Range(msg.cursorPosition.row, msg.cursorPosition.column, msg.cursorPosition.row, msg.cursorPosition.column+1);
				// vlozime kurzor do editoru
				editor.session.addMarker(rng, msg.sharingConfig.user, true);

				// rozeslu ostatnim uzivatelum pozici meho kurzoru
				socket.emit('show my position', {sharingConfig : sharingConfig, cursorPosition : editor.selection.getCursor()});
			});

			// spolupracovnik na rika, kde ma svuj kursor v editoru
			socket.on('show my position', function (msg){
				removeUserCursorFromEditor(msg.sharingConfig.user);
				// vygenerujeme uzivateli barvu
				generateCursorStyle(msg.sharingConfig.user);
				var Range = ace.require('ace/range').Range;
				var rng = new Range(msg.cursorPosition.row, msg.cursorPosition.column, msg.cursorPosition.row, msg.cursorPosition.column+1);
				// vlozime kurzor do editoru
                                editor.session.addMarker(rng, msg.sharingConfig.user, true);
				socket.emit('who collaborate', {sharingConfig : sharingConfig});	
			});
		
			socket.on('check collaborators', function (msg){
				// zobrazeni seznamu spolupracovniku, protoze nekdo zahajil spolupraci a zasila nam svuj login
				$('#collaborators_list').show();
				// kontrola spolupracovniku v seznamu
				addUserCollaboratesList(msg.sharingConfig.user);
				// zasleme zpet spolupracovnikum svuj login a tim rekneme, ze spolupracujeme
				var shrConf = {user : getUserName(), idRoom : msg.sharingConfig.idRoom};
				socket.emit('tell login', {sharingConfig : shrConf});
			});

			socket.on('tell login', function (msg){
				// zobrazeni seznamu spolupracovniku, protoze nekdo zahajil spolupraci a zasila nam svuj login
                                $('#collaborators_list').show();
				// nekdo nam rika, ze s nami spolupracuje, rika nam svuj login
                                addUserCollaboratesList(msg.login);
                        });
			
			// udalost, ktera se vola, kdyz se nejaky spolupracovnik odpoji z nasdileneho dokumentu
			socket.on('user disconnected', function (msg){
                       		// odstranime daneho uzivatele ze seznamu spolupracovniku
				removeUserCollaboratesList(msg.login);
				// odstranime take jeho kurzor z editoru
				removeUserCursorFromEditor(msg.login);
                        });
			
			// Promenna obsahujici pozici kurzoru klienta v predchozi akci, ktera se udala v editoru.
			// Pouziva se pro kontoru v pripade, ze klient maze blokove vice radku	
			var previousClientCursor = null;

			// Udalost zachycujici zmeny provedene v editoru
			editor.on('change', function (event){
				var clientCursor = editor.selection.getCursor();
				var clientCursorCol = clientCursor.column;
				var clientCursorRow = clientCursor.row;
				
				var changesCursorCol = event.data.range.start.column;
				var changesCursorRow = event.data.range.start.row;
				
				// Pokud se sourdnice, kde provedene zmeny zacaly rovnaji souradnicim klientova kursoru v okamziku zmeny dokumentu
				// pak se jedna o klientovi zmeny a je nutne je zaslat spolupracovnikum
				if (clientCursorCol == changesCursorCol && clientCursorRow == changesCursorRow && sharingConfig != null) {
					socket.emit('document changes', {sharingConfig : sharingConfig, editorChanges : event, colaboratorsCursor : clientCursor});
				} else if (event.data.action == 'removeText' && previousClientCursor.row == changesCursorRow && previousClientCursor.column == changesCursorCol 
					   && sharingConfig != null) {
					socket.emit('document changes', {sharingConfig : sharingConfig, editorChanges : event, colaboratorsCursor : clientCursor});
				}

				previousClientCursor = clientCursor;
			});
				
    			editor.getSession().selection.on('changeCursor', function (event) {
				if (sharingConfig != null)
					socket.emit('cursor changes', {sharingConfig : sharingConfig, cursor : editor.selection.getCursor()});
			});

			editor.getSession().selection.on('changeSelection', function (event) {
				var rng = editor.selection.getRange();
				var clientCursor = editor.selection.getCursor();
			
				if (clientCursor.row == rng.start.row && clientCursor.column == rng.start.column) { 
				//	socket.emit('range changes', {sharingConfig : sharingConfig, range : rng} );
				}
			});

			// Událost zachycující, že uživatel odešel ze sdíleného dokumentu, tím přestal sdílet
			$( window ).unload(function() {
				if (sharingConfig != null) 
					socket.emit('user disconnected', {sharingConfig : sharingConfig});
			});
		}

		// Kliknuti na ikonu sdileni v horni liste aplikace
		$( "#collaborators_list" ).click(function() {
			$( "#collaboratorsReview" ).toggle();
		});

		// Kliknuti na polozku Sdilet ve spravci souboru
		$( "#share" ).click(function() {
                        $( "#overlay" ).show();
			var filename = getFileActual();
			openShareMenu(filename)	
                });

		// Reakce na tlacitko pro uzavreni menu sdileni
		$( "#close_sharing" ).click(function() {
    			closeShareMenu();
                });

		// Reakce na tlacitko pro Prestat sdilet v  menu sdileni
                $( "#stop_sharing" ).click(function() {
			var shareConfFileName = getFileActual();
                    	shareConfFileName = "." + shareConfFileName + ".share";
			var pth = getPath();
			stopSharing(pth, shareConfFileName);
                        closeShareMenu();
			readFiles(pth);
                });

		// Reakce na tlacitko Zmenit a Sdilet
		$( "#submit_sharing" ).click(function() {
                    var shareUsersSent = $("#selected_users li span").text();
		    var shareConfFileName = getFileActual();
		    shareConfFileName = "." + shareConfFileName + ".share";
		    var pth = getPath();

		    // seznam spolupracovniku je prazdny
		    if (shareUsersSent == "") {
			if (modifyCollaborators) {
			// soubor byl jiz nekomu nasdilen, protoze je seznam spolupracovniku prazdny, prestaneme ho sdilet
				stopSharing(pth, shareConfFileName);
			} else {
			// soubor jeste nebyl sdilen, proto je nutne zadat nejake spolupracovniky	
		    		alert(TranslVar[497]);
				return false;
			}
		    } else {	
		    // seznam spolupracovniku obsahuje alespon jeden login
			shareUsersSent = shareUsersSent.trim();		
		    	shareUsersSent = shareUsersSent.split("\n");
			shareUsersSent = shareUsersSent.join(",");
			var parameters = "";

			if (modifyCollaborators) 
				parameters =  {modify : "modify", path : pth, filename : shareConfFileName, shareUsers : shareUsersSent}		
			else 
				parameters =  {create : "create", path : pth, filename : shareConfFileName, shareUsers : shareUsersSent}
				
			$.post("sprava_sdileni.pl", parameters, function(data) {
				closeShareMenu();
				// Neco by se asi melo stat, nejspis zacit sdilet.	
			});
		    }	
		    readFiles(pth);
                });

		 // Ziskani seznamu vsech uzivatelů TeXonWeb a nastaveni autocomplete
		 $.post("seznam_uzivatelu.pl", function(data) {
                	var users = data.toString().split(",");
                	
			$( "#users_sharing" ).autocomplete({
                        	source: users,

                        	select: function( event, ui ) {
                                	var user = ui.item.value;
					$( "#users_sharing" ).val("");
					var users = $("#selected_users li span").text();
					if (users.indexOf(user) == -1) { 
                                		// Pridani vybraneho uzivatele do seznamu pro sdileni dokumentu
                                		$("#selected_users").append("<li class='editable'><span>" + user + "</span></li>");
					} else {
						alert(TranslVar[498]);	
					}
					return false;
                        	}
                 	});

			$( "#users_sharing" ).autocomplete('widget').css('z-index', 150);
 
        	 });

		 $(document).on("click", "#selected_users li.editable", function(event) {
			if(event.target.tagName == "LI")
				$(this).remove();
		 });
	}
});

// globalni promena, ktera indikuje, zda soubor byl jiz nekomu nasdilen ci ne
var modifyCollaborators = false;


function openShareMenu(fileName) {
	initShareMenu(fileName);
}

function closeShareMenu() {
	 $( "#overlay" ).hide();
         $( "#menu_sharing" ).hide();
}

// Inicializace menu pro sdileni
function initShareMenu(fileName) {
	var pth = getPath();

	// vytvoreni jmena souboru s informacemi o sdilenem souboru
	fileName = "." + fileName + ".share"
	// Kontrola zda existuje soubor s informacemi o sdilenem souboru a nasledna inicializace menu pro sdileni
	$.post("sprava_sdileni.pl", {isFileShared: "isFileShared", path:pth, filename: fileName}, function(data){
		if (data == "true") {
			modifyCollaborators = true;
			// Soubor je jiz sdilen
			$.post("sprava_sdileni.pl", {getCollaborators: "getCollaborators", path:pth, filename: fileName}, function(data){
				var listOfCollaborators = "";
				var colaborators = data;
				colaborators = colaborators.split(",");
				
				if (colaborators.length > 0){
					for (var i=0; i<colaborators.length; i++) {
						listOfCollaborators += "<li class='editable'><span>" + colaborators[i] + "\n" + "</span></li>"; 	
					}			
				}

				$( "#share_instruction" ).html(TranslVar[501]);
				$( "#selected_users" ).removeClass('readonly');
				$( "#selected_users" ).html(listOfCollaborators);
				$( "#stop_sharing" ).show();
				$( "#searching_users" ).show();
                        	$( "#submit_sharing" ).text(TranslVar[475]);
				$( "#submit_sharing" ).show();
			});
		} else {
			var fileType = $( "#xtable td[abbr='"+ getFileActual() +"']" ).attr( "ftype" ); 
			modifyCollaborators = false;

			if (fileType == "l") {
				// Soubor je nekym vysdileny, uzivatel neni vlastnikem
				// Soubor je symbolicky link, ma nastaveny fileType = l

				$.post("sprava_sdileni.pl", {getCollaborators: "getCollaborators", path:pth, filename: fileName}, function(data){
                                	var listOfCollaborators = "";
                                	var colaborators = data;
                                	colaborators = colaborators.split(",");

                                	if (colaborators.length > 0){
                                        	for (var i=0; i<colaborators.length; i++) {
							if (colaborators[i] != getUserName()) {
                                                		listOfCollaborators += "<li><span>" + colaborators[i] + "\n" + "</span></li>";
							}
                                        	}
                                	}
					
					$( "#share_instruction" ).html(TranslVar[502]);
					$( "#selected_users" ).addClass('readonly');
					$( "#selected_users" ).html(listOfCollaborators);
					$( "#stop_sharing" ).hide();
					$( "#searching_users" ).hide();
					$( "#submit_sharing" ).hide();	
				});	
			} else {
				// Soubor neni sdilen 
				// Soubor je obycejny soubor, ma nastaveny fileType = f
				$( "#share_instruction" ).html(TranslVar[501]);
                        	$( "#selected_users" ).html("");
				$( "#selected_users" ).removeClass('readonly');
                        	$( "#stop_sharing" ).hide();
				$( "#searching_users" ).show();
                        	$( "#submit_sharing" ).text(TranslVar[496]);
				$( "#submit_sharing" ).show();
			} 
		}

		$( "#users_sharing" ).val("");
		$( "#menu_sharing" ).show();
	});
}

// funkce, ktera prejmenuje symlinky spolupracovnikum, pokud je prejmenovavany soubor s nekym sdilen
function renameFileToColaborators(pth, oldFileName, newFileName) {
	oldFileName = "." + oldFileName + ".share";
	newFileName = "." + newFileName + ".share";
        // kontrola zda existuje soubor s informacemi o sdilenem souboru a nasledna inicializace menu pro sdileni
        $.post("sprava_sdileni.pl", {isFileShared: "isFileShared", path:pth, filename: oldFileName}, function(data){
		// pokud jste vlastnikem, prejmenuj i ostatnim spolupracovnikum
		if (data == "true") {
			$.post("sprava_sdileni.pl", {renameSharedFile: "renameSharedFile", path:pth, filename: oldFileName, newFileName: newFileName}, function(data){
				// nacteni souboru do spravce souboru
				readFiles(pth);		
			});
		} else {
			// nacteni souboru do spravce souboru
			readFiles(pth);
		}
	});	
}

// funkce, ktera smaze symlinky spolupracovnikum, pokud je smazany soubor s nekym sdilen
function deleteFileToColaborators(pth, fileName) {
	fileName = "." + fileName + ".share";
        // kontrola zda existuje soubor s informacemi o sdilenem souboru a nasledna inicializace menu pro sdileni
        $.post("sprava_sdileni.pl", {isFileShared: "isFileShared", path:pth, filename: fileName}, function(data){
                // pokud jste vlastnikem, smaz i ostatnim spolupracovniku
		if (data == "true") {
                        $.post("sprava_sdileni.pl", {stopSharing : "stopSharing", path : pth, filename : fileName} ,function(data) {
				readFiles(pth);
        		});
                } else {	
			// nacteni souboru do spravce souboru 
                        readFiles(pth);
                }
        });
}

// funkce, ktera prestane sdilet vybrany soubor
function stopSharing(pth, sharedFileName) {
	$.post("sprava_sdileni.pl", {stopSharing : "stopSharing", path : pth, filename : sharedFileName} ,function(data) {
        	closeShareMenu();
        });
}

// Prekontrolu zda uzivatel v parametru je v seznamu spolupracovniku, pokud ano, tak ho neprida, pokud ne, tak prida jeho login
function addUserCollaboratesList(login) {
	var collaborators = $('#collaboratorsReview ul li');	
	var color = $('.'+login).css("background-color");	

	if (collaborators.length <= 0 ) {
		$('#collaboratorsReview ul').html("<li class='"+login+"Bullet'>"+login+"</li>");
	} else {
		var isInList = false;
		collaborators.each(function (index, element){
			if ( $(element).text() == login)
				isInList = true;
		});
		
		if (!isInList)	{
			var newList = $('#collaboratorsReview ul').html() + "<li class='"+login+"Bullet'>"+login+"</li>";
			$('#collaboratorsReview ul').html(newList);
		}
	}
	$('.'+login+'Bullet').css({'color' : 'white', 'background-color' : color});
}

function removeUserCollaboratesList(login) {
	var collaborators = $('#collaboratorsReview ul li');
	collaborators.each(function (index, element){
                        if ( $(element).text() == login) {
                                $(element).remove();
			}
        });

	collaborators = $('#collaboratorsReview ul li');
		
	// pokud uz nikdo nesdili, skryjeme seznam spolupracovniku
	if (collaborators.length <= 0) {
		$('#collaborators_list').hide();		
	}	
}

function generateCursorStyle(login) {
	var red = getRandomInt(0, 256);
	var green = getRandomInt(0, 256);
	var blue = getRandomInt(0, 256);

	while (red == green || red == blue || green == blue || (red - blue) < 30 || (red - green) < 30) {
		red = getRandomInt(0, 256);
		green = getRandomInt(0, 256);
		blue = getRandomInt(0, 256);
	}	

	$("<style type='text/css'> ."+login+"{ position:absolute; background:rgb("+red+","+green+","+blue+"); z-index:40; width:2px!important;}" +
	"."+login+":before{position:absolute;background:rgb("+red+","+green+","+blue+");z-index:999;top: 100%;content:'"+login+"';}</style>").appendTo("head");
}

function getRandomInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

// odstraneni markeru (kurzoru) z editoru
function removeUserCursorFromEditor(login){
	var markers = editor.session.getMarkers();
	var marker = null;

	$.each(markers, function (index, value) {
		if(markers[index].clazz == login) {
			marker = markers[index];
			return false;
		}
	});

	// odstraneni stareho kurzoru uzivatele, ktery provedl zmeny
	if (marker != null) {
		editor.session.removeMarker(marker.id);
	}
}
