TOW.Statusbar = {

    init: function() {
        this.initElements();
        this.bindEvents();
    },


    initElements: function() {
        this.$statusbar = $('#statusbar');
        this.$fileName = $('#statusFileName');
        this.$fileChanged = $('#statusFileChanged');

        this.setFileName();
    },


    bindEvents: function() {
        var self = this;

        editor.getSession().on('change', function() {
            self.setFileChanged(true);
        });

        $(document).on('fileSaved', function() {
            self.setFileChanged(false);
        });
    },


    setFileName: function() {
        var fileName = this.getUrlParameter('soubor');
        if (fileName) {
            this.$fileName.text(fileName);
        } else {
            this.$fileName.text('');
        }
    },


    setFileChanged: function(changed) {
        if (changed) {
            this.$fileChanged.show();
        } else {
            this.$fileChanged.hide();
        }
    },


    getUrlParameter: function(sParam) {
        var sPageURL = window.location.search.substring(1);
        var sURLVariables = sPageURL.split('&');
        for (var i = 0; i < sURLVariables.length; i++) {
            var sParameterName = sURLVariables[i].split('=');
            if (sParameterName[0] == sParam) {
                return sParameterName[1];
            }
        }
    }

};



$(function() {
    TOW.Statusbar.init();
    TOW.Statusbar.$fileChanged.tooltipster({
        content: 'Soubor není uložen'
    });
});
